package nc.pub.filesystem.newui;

import java.awt.BorderLayout;
import java.util.ArrayList;
import java.util.Collection;

import nc.ui.pub.beans.ScaleSlider;
import nc.vo.pub.filesystem.FileTypeConst;
import nc.vo.pub.filesystem.NCFileNode;
import nc.vo.pub.filesystem.NCFileVO;
/**
 * ʽ panel ʾ
 * @author zhoujja
 *
 */
public class ThFileBrowseCreatePane {
	/**
	 * ͼʾ
	 * @param parentpanel
	 */
	protected static void  createSmallImagePane(ThFileContentPanel parentpanel) {
		NCFileNode selnode =  parentpanel.selfoldernode;
		Collection<NCFileVO> ncfilevos  =null ;
		if(selnode==null||selnode.getFullPath().equalsIgnoreCase(parentpanel.rootDirStr)){
			ncfilevos = parentpanel.getTreenodefilecacheMap().get("root");
		}else{
			ncfilevos = parentpanel.getTreenodefilecacheMap().get(selnode.getFullPath());
		}
		ArrayList<NCFileVO> listimagefilevo = new ArrayList<NCFileVO>();
		//гͼƬ
		if(ncfilevos!=null)
		for(NCFileVO fvo:ncfilevos){
			if(fvo.getFiletype()!=null &&fvo.getFiletype().equals(FileTypeConst.IMAGE)){
				listimagefilevo.add(fvo);
			}
		}
		parentpanel.refreshStatuBar();
//		
		if(listimagefilevo==null||listimagefilevo.size()==0){
			if(parentpanel.PAGE_STATE==parentpanel.BROWSESMALLICON_STATE){
				parentpanel.getTablepanel().removeAll();
				parentpanel.getTablepanel().updateUI();
			}
//			MessageDialog.showErrorDlg(parentpanel, NCLangRes.getInstance().getStrByID("sftemp", "UploadURLAction-0005")/*ʾ*/, NCLangRes.getInstance().getStrByID("sftemp", "FileBrowseCreatePane-0000")/*δûͼƬ͸*/);
			
			return ;
		}
		//ϴĸĽڵûݿȡص
		FileBroseConst.setFileVOPK(listimagefilevo);
		
		parentpanel.getTablepanel().removeAll();
		parentpanel.getTablepanel().add(new ThSmallImageBrowsePanel(listimagefilevo,parentpanel),BorderLayout.CENTER);
		
		parentpanel.getTablepanel().updateUI();
		parentpanel.getScaleSliderPane().removeAll();
		parentpanel.getScaleSliderPane().updateUI();
	}
	/**
	 * бʾ
	 * @param parentpanel
	 */
	protected static void  createListBrowsePane(ThFileContentPanel parentpanel){
		parentpanel.getTablepanel().removeAll();
//		
		NCFileVO[] arr_treevos;
		if(parentpanel.getPatchInfoTable().getCellEditor()!=null){
			parentpanel.getPatchInfoTable().getCellEditor().stopCellEditing();
		}
		if (parentpanel.selfoldernode==null||parentpanel.selfoldernode.getFullPath().equalsIgnoreCase(parentpanel.rootDirStr)) {
			if (parentpanel.getTreenodefilecacheMap().get("root") != null) {
				// ±
				arr_treevos = parentpanel.getTreenodefilecacheMap().get("root").toArray(
						new NCFileVO[0]);
				parentpanel.getfiletablemodel().clearTable();
				parentpanel.getfiletablemodel().addVO(arr_treevos);
				parentpanel.getfiletablemodel().refreshTable();
				parentpanel.getPatchInfoTable().repaint();
				if (parentpanel.getPatchInfoTable().getRowCount() > 0) {
					parentpanel.getPatchInfoTable().setRowSelectionInterval(0, 0);
				}
				
				// ״̬(С)
				//refresh statusbar 
				parentpanel.refreshStatuBar();
				
			}else{
				
			}
		}
		else if (parentpanel.selfoldernode!=null&&parentpanel.getTreenodefilecacheMap().get(parentpanel.selfoldernode.getFullPath()) != null) {
			arr_treevos = parentpanel.getTreenodefilecacheMap().get(
					parentpanel.selfoldernode.getFullPath()).toArray(new NCFileVO[0]);
			parentpanel.getfiletablemodel().clearTable();
			parentpanel.getfiletablemodel().addVO(arr_treevos);
			parentpanel.getfiletablemodel().refreshTable();
			parentpanel.getPatchInfoTable().repaint();
			if (parentpanel.getPatchInfoTable().getRowCount() > 0) {
				parentpanel.getPatchInfoTable().setRowSelectionInterval(0, 0);
			}
			//refresh statusbar 
			// ״̬(С)
			parentpanel.refreshStatuBar();
			
		}else{
			parentpanel.getfiletablemodel().clearTable();
			// ״̬(С)
			//refresh statusbar 
			parentpanel.refreshStatuBar();
		}
		
		parentpanel.getTablepanel().add(parentpanel.getJstablepanel(),BorderLayout.CENTER);
		parentpanel.getTablepanel().updateUI();
		
		parentpanel.getScaleSliderPane().removeAll();
		parentpanel.getScaleSliderPane().updateUI();
	}
	/**
	 * ʾ
	 * @param parentpanel
	 * @param scaleSlider
	 */
	protected static void  createSingleBrosePane(ThFileContentPanel parentpanel,ScaleSlider scaleSlider ){
		NCFileNode selnode =  parentpanel.selfoldernode;
		Collection<NCFileVO> ncfilevos  =null ;
		if(selnode==null||selnode.getFullPath().equalsIgnoreCase(parentpanel.rootDirStr)){
			ncfilevos = parentpanel.getTreenodefilecacheMap().get("root");
		}else{
			ncfilevos = parentpanel.getTreenodefilecacheMap().get(selnode.getFullPath());
		}
		ArrayList<NCFileVO> listimagefilevo = new ArrayList<NCFileVO>();
		//гͼƬ
		if(ncfilevos!=null)
		for(NCFileVO fvo:ncfilevos){
			if(fvo.getFiletype()!=null &&fvo.getFiletype().equals(FileTypeConst.IMAGE)){
				listimagefilevo.add(fvo);
			}
		}
//		
		parentpanel.refreshStatuBar();
		if(listimagefilevo==null||listimagefilevo.size()==0){
			if(parentpanel.PAGE_STATE==parentpanel.BROWSESINGLEICON_STATE){
				parentpanel.getTablepanel().removeAll();
				parentpanel.getTablepanel().updateUI();
			}
//			MessageDialog.showErrorDlg(parentpanel, NCLangRes.getInstance().getStrByID("sftemp", "UploadURLAction-0005")/*ʾ*/, NCLangRes.getInstance().getStrByID("sftemp", "FileBrowseCreatePane-0000")/*δûͼƬ͸*/);			
			return ;
		}
		//ϴĸĽڵûݿȡص
		FileBroseConst.setFileVOPK(listimagefilevo);
		parentpanel.getScaleSliderPane().removeAll();
		parentpanel.getScaleSliderPane().add(scaleSlider);
		parentpanel.getScaleSliderPane().updateUI();
		parentpanel.getTablepanel().removeAll();
		parentpanel.getTablepanel().add(new ThSingleImageBrowsePanel(listimagefilevo,parentpanel,scaleSlider));
		parentpanel.getTablepanel().repaint();
		parentpanel.getTablepanel().updateUI();
	}
	protected static void  createPPTBrowsePane(ThFileContentPanel parentpanel,ScaleSlider scaleSlider ){
		NCFileNode selnode =  parentpanel.selfoldernode;
		Collection<NCFileVO> ncfilevos  =null ;
		if(selnode==null||selnode.getFullPath().equalsIgnoreCase(parentpanel.rootDirStr)){
			ncfilevos = parentpanel.getTreenodefilecacheMap().get("root");
		}else{
			ncfilevos = parentpanel.getTreenodefilecacheMap().get(selnode.getFullPath());
		}
		ArrayList<NCFileVO> listimagefilevo = new ArrayList<NCFileVO>();
		//гͼƬ
		if(ncfilevos!=null)
		for(NCFileVO fvo:ncfilevos){
			if(fvo.getFiletype()!=null &&fvo.getFiletype().equals(FileTypeConst.IMAGE)){
				listimagefilevo.add(fvo);
			}
		}
//		
		parentpanel.refreshStatuBar();
		if(listimagefilevo==null||listimagefilevo.size()==0){
			if(parentpanel.PAGE_STATE==parentpanel.BROWSEPPTICON_STATE){
				parentpanel.getTablepanel().removeAll();
				parentpanel.getTablepanel().updateUI();
			}
//			MessageDialog.showErrorDlg(parentpanel, NCLangRes.getInstance().getStrByID("sftemp", "UploadURLAction-0005")/*ʾ*/, NCLangRes.getInstance().getStrByID("sftemp", "FileBrowseCreatePane-0000")/*δûͼƬ͸*/);			
			return ;
		}
		
		//ϴĸĽڵûݿȡص
		FileBroseConst.setFileVOPK(listimagefilevo);
		
		//̬
		parentpanel.getScaleSliderPane().removeAll();
		parentpanel.getScaleSliderPane().add(scaleSlider);		
		parentpanel.getScaleSliderPane().updateUI();
		parentpanel.getTablepanel().removeAll();
		parentpanel.getTablepanel().add(new ThPPTBrosePanel(listimagefilevo,parentpanel,scaleSlider));
		
		parentpanel.getTablepanel().repaint();
		parentpanel.getTablepanel().updateUI();		

	}
}
