package nc.bs.ic.base;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;

import nc.bs.businessevent.IBusinessEvent;
import nc.bs.businessevent.IBusinessListener;
import nc.bs.framework.common.NCLocator;
import nc.bs.pu.event.PUBusinessEvent;
import nc.impl.pubapp.pattern.rule.IRule;
import nc.itf.uap.IUAPQueryBS;
import nc.jdbc.framework.processor.ColumnProcessor;
import nc.jdbc.framework.processor.MapListProcessor;
import nc.md.persist.framework.IMDPersistenceQueryService;
import nc.vo.bd.defdoc.DefdocVO;
import nc.vo.pu.m25.entity.InvoiceItemVO;
import nc.vo.pu.m25.entity.InvoiceVO;
import nc.vo.pub.lang.UFDate;
import nc.vo.pub.lang.UFDouble;
import nc.vo.pubapp.pattern.exception.ExceptionUtils;


/**
 * ɹƱУ
 * @author Yaoyu
 * 2023-05-25
 *
 */
public class InvoiceAfterCheckEvent implements IRule<InvoiceVO>{
	
	
	private IUAPQueryBS bs = NCLocator.getInstance().lookup(IUAPQueryBS.class);
	private IMDPersistenceQueryService service = NCLocator.getInstance().lookup(IMDPersistenceQueryService.class);



	@Override
	public void process(InvoiceVO[] vos) {
		try {
			if (vos instanceof InvoiceVO[]) {
				InvoiceVO InvoiceVO = (InvoiceVO) vos[0];
				InvoiceItemVO[] arrInvoiceItemVO = (InvoiceItemVO[]) InvoiceVO.getChildren(InvoiceItemVO.class);
				//εݵϢͷƱϢһУ(̧ͷ˰)
				//Ʊɳɹͬ/
				//򷽷Ʊ̧ͷ˰׼ȷ
				Boolean vbdboo = false;
				Boolean idboo = false;
				//Դ
				String csourcetypecode = arrInvoiceItemVO[0].getCsourcetypecode();
				//Դ
				String csourceid = arrInvoiceItemVO[0].getCsourceid();
				List<Map<Object, Object>> listMap = new ArrayList<Map<Object, Object>>();
				//Դǲɹ
				if("21".equals(csourcetypecode)) {
					StringBuffer sql = new StringBuffer();
					sql.append("SELECT");
					sql.append(" po_order_b.pk_order_b,");
					sql.append(" po_order_b.norigtaxmny,");
					sql.append(" po_order_b.ntaxrate,");
					sql.append(" po_order_b.nmny,");
					sql.append(" po_order_b.ntax");
					sql.append(" FROM");
					sql.append(" po_order po_order");
					sql.append(" LEFT JOIN po_order_b po_order_b ON po_order.pk_order = po_order_b.pk_order");
					sql.append(" WHERE");
					sql.append(" po_order.pk_order = '"+csourceid+"'");
					sql.append(" and po_order.dr = 0 and po_order_b.dr = 0");
					listMap = (List<Map<Object, Object>>) bs.executeQuery(sql.toString(), new MapListProcessor());                
				}else
				//Դⵥ
				if("45".equals(csourcetypecode)) {
					StringBuffer sql = new StringBuffer();
					sql.append("SELECT");
					sql.append(" ic_purchasein_b.cgeneralbid,");
					sql.append(" po_order_b.pk_order_b,");
					sql.append(" po_order_b.norigtaxmny,");
					sql.append(" po_order_b.ntaxrate,");
					sql.append(" po_order_b.nmny,");
					sql.append(" po_order_b.ntax");
					sql.append(" FROM");
					sql.append(" ic_purchasein_h ic_purchasein_h");
					sql.append(" LEFT JOIN ic_purchasein_b ic_purchasein_b ON ic_purchasein_h.cgeneralhid = ic_purchasein_b.cgeneralhid");
					sql.append(" LEFT JOIN po_order_b po_order_b ON ic_purchasein_b.csourcebillbid = po_order_b.pk_order_b");
					sql.append(" WHERE");
					sql.append(" ic_purchasein_h.cgeneralhid = '"+csourceid+"'");
					sql.append(" and ic_purchasein_h.dr = 0 and ic_purchasein_b.dr = 0 and po_order_b.dr = 0");
					listMap = (List<Map<Object, Object>>) bs.executeQuery(sql.toString(), new MapListProcessor());
				}
				//
				UFDouble nmny1 = new UFDouble();
				UFDouble nmny2 = new UFDouble();
				//˰
				UFDouble ntax1 = new UFDouble();
				UFDouble ntax2 = new UFDouble();
				//˰ϼ
				UFDouble norigtaxmny1 = new UFDouble();
				UFDouble norigtaxmny2 = new UFDouble();
				for (Map<Object, Object> map : listMap) {
					 norigtaxmny2 = norigtaxmny2.add(new UFDouble(map.get("norigtaxmny").toString()));
					 nmny2 = nmny2.add(new UFDouble(map.get("nmny").toString()));
					 ntax2 = ntax2.add(new UFDouble(map.get("ntax").toString()));
				}
				for (InvoiceItemVO invoiceItemVO : arrInvoiceItemVO) {
				//ûƱȽڡ̧ͷ˰ʶš˰
					if(invoiceItemVO.getVbdef20() != null && !"".equals(invoiceItemVO.getVbdef20())) {
						vbdboo = true;
						String[] arrVbdef20 = invoiceItemVO.getVbdef20().split(",");
						for(String Vbdef20 : arrVbdef20) {
							DefdocVO defdocVO = (DefdocVO) service.queryBillOfNCObjectByPKWithDR(DefdocVO.class, Vbdef20, true).getContainmentObject();
							if(defdocVO.getPid() != null) {
								UFDate date = new UFDate(System.currentTimeMillis());
								UFDate date2 = new UFDate(defdocVO.getPid());
								//ֻܱĿ
								if(date.getYear() != date2.getYear()) {
									ExceptionUtils.wrappBusinessException(":"+invoiceItemVO.getCrowno()+"ܿ걨Ʊ!");
								}
							}
							//ⷢƱ̧ͷ˰ʶſɲУ
							if(defdocVO.getName2() != null && !"".equals(defdocVO.getName2())) {
								//Ƚ̧ͷ
								String sql1 = "select name from org_financeorg_v where pk_vid ='"+InvoiceVO.getParent().getAttributeValue("pk_org_v")+"'";
								String orgname = (String) bs.executeQuery(sql1, new ColumnProcessor());
								// ʹʽ滻ΪӢ
								String orgnames = orgname.replaceAll("", "(").replaceAll("", ")");
								String name2 = defdocVO.getName2().replaceAll("", "(").replaceAll("", ")");
								
								//Ϻ컪׽޹˾() Ϻ컪׽޹˾ҹ˾Ϻ컪׽޹˾̧ͷ
								//Ϻ컪׽޹˾()Ƶʱȥ()֤ʹͬһ̧ͷ
								if("Ϻ컪׽޹˾()".equals(orgnames)) {
									 orgnames = orgnames.replace("()", "");
								}
								if(!orgnames.equals(name2)) {
									
									ExceptionUtils.wrappBusinessException("Ʊ̧ͷ֯һ£޸Ĳ֯!");
								}
								//Ƚ˰ʶ
								StringBuffer sql2 = new StringBuffer();
								sql2.append("SELECT");
								sql2.append(" name");
								sql2.append(" FROM");
								sql2.append(" bd_defdoc ");
								sql2.append(" WHERE");
								sql2.append(" pk_defdoclist = ( SELECT pk_defdoclist FROM bd_defdoclist WHERE code = 'CORPYS04' ) ");
								sql2.append(" AND memo = '"+name2+"' ");
								sql2.append(" AND enablestate = 2");
								String tcode = (String) bs.executeQuery(sql2.toString(), new ColumnProcessor());
								String mnecode = defdocVO.getMnecode() == null ? "" : defdocVO.getMnecode();
								if(!mnecode.equals(tcode)) {
									ExceptionUtils.wrappBusinessException(":"+invoiceItemVO.getCrowno()+"˰ʶŲȷ! 鷢Ʊ˰ʶźԶ嵵Ƿȷ!");
								}
							}
						}
						for (Map<Object, Object> map : listMap) {
							//ֻζıȽ˰
							if(invoiceItemVO.getCsourcebid() != null) {
								idboo = true;
								if (invoiceItemVO.getCsourcebid().equals(map.get("pk_order_b")) || invoiceItemVO.getCsourcebid().equals(map.get("cgeneralbid"))) { 
									//Ƚ˰
									UFDouble ntaxrate1 = invoiceItemVO.getNtaxrate();
									UFDouble ntaxrate2 = new UFDouble(map.get("ntaxrate").toString());
									if(ntaxrate1.compareTo(ntaxrate2) != 0) {
										ExceptionUtils.wrappBusinessException(":"+invoiceItemVO.getCrowno()+"ɹ˰ʲͬ!");
									}
								}
							}
						}
					}
					norigtaxmny1 = norigtaxmny1.add(invoiceItemVO.getNorigtaxmny());
					nmny1 = nmny1.add(invoiceItemVO.getNmny());
					ntax1 = ntax1.add(invoiceItemVO.getNtax());
					
				}
				//ûʹocrûβȽϽ
				if(vbdboo && idboo) {
					//ȽϽ
					if(nmny1.compareTo(nmny2) == 1) {
						ExceptionUtils.wrappBusinessException("ɳɹ!");
					}
					//Ƚ˰
					if(ntax1.compareTo(ntax2) == 1) {
						ExceptionUtils.wrappBusinessException("ɳɹ˰!");
					}
					//Ƚϼ˰ϼ							 
					if(norigtaxmny1.compareTo(norigtaxmny2) == 1) {
						ExceptionUtils.wrappBusinessException("ɳɹ˰ϼƽ!");
					}
				}
			}
			
		} catch (Exception e) {
			ExceptionUtils.wrappBusinessException(""+e.getMessage());
		}
	}
}